import java.util.Hashtable;

public class Cell
{
  private char      myToken;
  private Neighbors neighbor;
  
  public Cell()
  {
    myToken = ' ';
    neighbor = new Neighbors();
  }
  
  public void accept( char dir, Cell c )
  {
    neighbor.add( dir, c );
  }
  
  public void move( char dir, char token )
  {
    // clear my location
    if ( myToken != ' ' )
    {
      Cell n = (Cell) neighbor.at(dir);
      if (n != null )
        n.move( dir, myToken );
    }
    
    // accept new token
    myToken = token;
  }
  
  public String display( char dir )
  {
    String result = "[" + myToken + "]";
    Cell n = (Cell) neighbor.at(dir);
    if (n != null )
      result += n.display( dir );
    return result;
  }
  
  public boolean isStraight( char dir )
  {
    return isStraight( dir, myToken );
  }
  
  // helper methods
  
  public boolean isStraight( char dir, char token )
  {
    Cell n = neighbor.at(dir);
    if (n != null )
      return myToken == token &&
             n.isStraight( dir, myToken );
    else
      return myToken == token;
  }
}