import java.io.InputStream;
import java.io.IOException;

public class CensorInputStream extends InputStream
{
  private InputStream dataSource;
  private int         charToRemove;
  private int         charToInsert;

  public CensorInputStream( InputStream s, char remove, char insert )
  {
    dataSource = s;
    charToRemove = (int) remove;
    charToInsert = (int) insert;
  }

  public int read() throws IOException
  {
    int c = dataSource.read();
    if ( c == charToRemove )
      return charToInsert;
    return c;
  }
}
