import java.io.FilterInputStream;
import java.io.InputStream;
import java.io.IOException;

public class CensorInputStream extends FilterInputStream
{
  private int charToRemove;
  private int charToInsert;

  public CensorInputStream( InputStream s, char remove, char insert )
  {
    super( s );
    charToRemove = (int) remove;
    charToInsert = (int) insert;
  }

  public int read() throws IOException
  {
    int c = super.read();
    if ( c == charToRemove )
      return charToInsert;
    return c;
  }
}
