//
// FILE:     DecoratedBall.java
// AUTHOR:   Eugene Wallingford
// DATE:     2012/11/28
// COMMENT:  a generic decorator for Balls
//
// MODIFIED: 
// CHANGE:   
//

import java.awt.Graphics;

public class DecoratedBall extends Ball
{
  private Ball delegate;

  public DecoratedBall( Ball b )
  {
    super();
    delegate = b;
  }

  public void move()
  {
    delegate.move();
  }

  public void paint( Graphics g )
  {
    delegate.paint( g );
  }
  
  protected void reverseDeltaX()
  {
    delegate.reverseDeltaX();
  }

  protected void reverseDeltaY()
  {
    delegate.reverseDeltaY();
  }

  protected void adjustSpeedBy( double ddx, double ddy )
  {
    delegate.adjustSpeedBy( ddx, ddy );
  }

  protected void adjustSpeedBy( double factor )
  {
    delegate.adjustSpeedBy( factor );
  }
  
  protected void moveBy( int deltaX, int deltaY )
  {
    delegate.moveBy( deltaX, deltaY );
  }
  
  protected int x()
  {
    return delegate.x();
  }
  
  protected int y()
  {
    return delegate.y();
  }
  
  protected void growBy( int pixels )
  {
    delegate.growBy( pixels );
  }
  
  protected void darker()
  {
    delegate.darker();
  }
  
  protected void lighter()
  {
    delegate.lighter();
  }
}
